package sun.audio;

import java.io.InputStream;
import java.security.AccessController;
import java.security.PrivilegedAction;

public final class AudioPlayer extends Thread
{
    private final AudioDevice devAudio;
    private static final boolean DEBUG = false;
    public static final AudioPlayer player;
    
    private static ThreadGroup getAudioThreadGroup() {
        ThreadGroup threadGroup;
        for (threadGroup = Thread.currentThread().getThreadGroup(); threadGroup.getParent() != null && threadGroup.getParent().getParent() != null; threadGroup = threadGroup.getParent()) {}
        return threadGroup;
    }
    
    private static AudioPlayer getAudioPlayer() {
        return (AudioPlayer)AccessController.doPrivileged(new PrivilegedAction() {
            @Override
            public Object run() {
                AudioPlayer audioPlayer = new AudioPlayer();
                audioPlayer.setPriority(10);
                audioPlayer.setDaemon(true);
                audioPlayer.start();
                return audioPlayer;
            }
        });
    }
    
    private AudioPlayer() {
        super(getAudioThreadGroup(), "Audio Player");
        (this.devAudio = AudioDevice.device).open();
    }
    
    public synchronized void start(InputStream inputStream) {
        this.devAudio.openChannel(inputStream);
        this.notify();
    }
    
    public synchronized void stop(InputStream inputStream) {
        this.devAudio.closeChannel(inputStream);
    }
    
    @Override
    public void run() {
        this.devAudio.play();
        while (true) {
            try {
                Thread.sleep(5000L);
                continue;
            }
            catch (Exception ex) {
                return;
            }
        }
    }
    
    AudioPlayer(AudioPlayer.1 privilegedAction) {
        this();
    }
    
    static {
        player = getAudioPlayer();
    }
}
